searchNodes=[{"doc":"This module defines the behavior a caller must implement.","ref":"CommonGraphQLClient.CallerBehaviour.html","title":"CommonGraphQLClient.CallerBehaviour","type":"behaviour"},{"doc":"","ref":"CommonGraphQLClient.CallerBehaviour.html#c:post/4","title":"CommonGraphQLClient.CallerBehaviour.post/4","type":"callback"},{"doc":"","ref":"CommonGraphQLClient.CallerBehaviour.html#c:subscribe/5","title":"CommonGraphQLClient.CallerBehaviour.subscribe/5","type":"callback"},{"doc":"","ref":"CommonGraphQLClient.CallerBehaviour.html#c:supervisor/2","title":"CommonGraphQLClient.CallerBehaviour.supervisor/2","type":"callback"},{"doc":"This module defines the behavior a schema must implement in order to be accessible through the native callers of this package. This module adds extendability to this package. By using this module and defining certain callbacks, a new set of resource can be very easily integrated with this API client.","ref":"CommonGraphQLClient.Schema.html","title":"CommonGraphQLClient.Schema","type":"module"},{"doc":"A Simple way of accessing all Schema&#39;s features","ref":"CommonGraphQLClient.Schema.html#__using__/1","title":"CommonGraphQLClient.Schema.__using__/1","type":"macro"},{"doc":"abstraction for an ecto embedded schema","ref":"CommonGraphQLClient.Schema.html#api_schema/1","title":"CommonGraphQLClient.Schema.api_schema/1","type":"macro"},{"doc":"Documentation for CommonGraphqlClient.","ref":"CommonGraphqlClient.html","title":"CommonGraphqlClient","type":"module"},{"doc":"Validates a query against a static graphql schema","ref":"CommonGraphqlClient.StaticValidator.html","title":"CommonGraphqlClient.StaticValidator","type":"module"},{"doc":"This method validates a query against a graphql schema and returns :ok if the query is valid or returns {:error, reason}. This method takes: a query_string: A graphql query string Options: Options for validation include: schema_string: Contents on graphql schema to validate the query for schema_path: Path to the file containing graphql schema validation_strategy: Way to validate schema. Could be done in multiple ways: :npm_graphql (needs npm cli) Uses npm calls to validate query :native (todo: parse schema in elixir) Will validate in pure elixir Examples: # When a schema file is given and the query is valid iex&gt; schema_path = &quot;./test/support/example_schema.json&quot; iex&gt; query_string = &quot;{ __schema { types { name } } }&quot; iex&gt; validation_strategy = :npm_graphql iex&gt; CommonGraphqlClient.StaticValidator.validate( ...&gt; query_string, ...&gt; %{ validation_strategy: validation_strategy, ...&gt; schema_path: schema_path } ...&gt; ) :ok # When a schema string is given and the query is valid iex&gt; schema_path = &quot;./test/support/example_schema.json&quot; iex&gt; schema_string = File.read!(schema_path) iex&gt; query_string = &quot;{ __schema { types { name } } }&quot; iex&gt; validation_strategy = :npm_graphql iex&gt; CommonGraphqlClient.StaticValidator.validate( ...&gt; query_string, ...&gt; %{ validation_strategy: validation_strategy, ...&gt; schema_string: schema_string } ...&gt; ) :ok # When query is invalid iex&gt; schema_path = &quot;./test/support/example_schema.json&quot; iex&gt; query_string = &quot;bad query string&quot; iex&gt; validation_strategy = :npm_graphql iex&gt; {:error, error} = CommonGraphqlClient.StaticValidator.validate( ...&gt; query_string, ...&gt; %{ validation_strategy: validation_strategy, ...&gt; schema_path: schema_path } ...&gt; ) iex&gt; Regex.match?(~r/Unexpected Name \\&quot;bad\\&quot;/, error) true # When schema is invalid iex&gt; schema_string = &quot;bad schema&quot; iex&gt; query_string = &quot;{ __schema { types { name } } }&quot; iex&gt; validation_strategy = :npm_graphql iex&gt; {:error, error} = CommonGraphqlClient.StaticValidator.validate( ...&gt; query_string, ...&gt; %{ validation_strategy: validation_strategy, ...&gt; schema_string: schema_string } ...&gt; ) iex&gt; Regex.match?(~r/bad schema/, error) true # When validation_strategy is native iex&gt; schema_string = &quot;someschema&quot; iex&gt; query_string = &quot;somequery&quot; iex&gt; validation_strategy = :native iex&gt; CommonGraphqlClient.StaticValidator.validate( ...&gt; query_string, ...&gt; %{ validation_strategy: validation_strategy, ...&gt; schema_string: schema_string } ...&gt; ) ** (RuntimeError) Not Implemented","ref":"CommonGraphqlClient.StaticValidator.html#validate/2","title":"CommonGraphqlClient.StaticValidator.validate/2","type":"function"},{"doc":"This module uses node and graphql-tools to validate a graphql query against a graphql schema It needs node binary to be available","ref":"CommonGraphqlClient.StaticValidator.NpmGraphql.html","title":"CommonGraphqlClient.StaticValidator.NpmGraphql","type":"module"},{"doc":"This method uses node &amp; graphql-tools validates a query against a graphql schema and returns :ok if the query is valid or returns {:error, reason}. This method takes: a query_string: A graphql query string a schema_string: Contents on graphql schema to validate the query for Options: validate options include: variables: Document variable values for the query (needs to be a Map) Examples: # When query is valid iex&gt; alias CommonGraphqlClient.StaticValidator.NpmGraphql iex&gt; schema_path = &quot;./test/support/example_schema.json&quot; iex&gt; schema_string = File.read!(schema_path) iex&gt; query_string = &quot;{ __schema { types { name } } }&quot; iex&gt; NpmGraphql.validate(query_string, schema_string) :ok # When query is invalid iex&gt; alias CommonGraphqlClient.StaticValidator.NpmGraphql iex&gt; schema_path = &quot;./test/support/example_schema.json&quot; iex&gt; schema_string = File.read!(schema_path) iex&gt; query_string = &quot;bad query string&quot; iex&gt; {:error, error} = NpmGraphql.validate(query_string, schema_string) iex&gt; Regex.match?(~r/Unexpected Name \\&quot;bad\\&quot;/, error) true # When schema is invalid iex&gt; alias CommonGraphqlClient.StaticValidator.NpmGraphql iex&gt; schema_string = &quot;bad schema&quot; iex&gt; query_string = &quot;{ __schema { types { name } } }&quot; iex&gt; {:error, error} = NpmGraphql.validate(query_string, schema_string) iex&gt; Regex.match?(~r/bad schema/, error) true # When query variables are passed iex&gt; alias CommonGraphqlClient.StaticValidator.NpmGraphql iex&gt; schema_path = &quot;./test/support/example_schema.json&quot; iex&gt; schema_string = File.read!(schema_path) iex&gt; query_string = &quot; ...&gt; query getUser($id: ID!) { ...&gt; user(id: $id) { ...&gt; id ...&gt; } ...&gt; } ...&gt; &quot; iex&gt; variables = %{id: 1} iex&gt; NpmGraphql.validate( ...&gt; query_string, ...&gt; schema_string, ...&gt; %{variables: variables} ...&gt; ) :ok","ref":"CommonGraphqlClient.StaticValidator.NpmGraphql.html#validate/3","title":"CommonGraphqlClient.StaticValidator.NpmGraphql.validate/3","type":"function"},{"doc":"Defines behaviour for validation strategies for static validations","ref":"CommonGraphqlClient.StaticValidator.ValidationStrategy.html","title":"CommonGraphqlClient.StaticValidator.ValidationStrategy","type":"behaviour"},{"doc":"Validates a query_string against a schema_string","ref":"CommonGraphqlClient.StaticValidator.ValidationStrategy.html#c:validate/3","title":"CommonGraphqlClient.StaticValidator.ValidationStrategy.validate/3","type":"callback"},{"doc":"Mix task to call static query validator","ref":"Mix.Tasks.Graphql.ValidateQuery.html","title":"Mix.Tasks.Graphql.ValidateQuery","type":"task"},{"doc":"","ref":"Mix.Tasks.Graphql.ValidateQuery.html#mix_raise/0","title":"Mix.Tasks.Graphql.ValidateQuery.mix_raise/0","type":"function"},{"doc":"This method is the entry point to mix graphql.validate_query task. It validates a graphql query against a given schema Example: # When query is valid iex&gt; schema_path = &quot;./test/support/example_schema.json&quot; iex&gt; schema_string = File.read!(schema_path) iex&gt; query_string = &quot;{ __schema { types { name } } }&quot; iex&gt; Mix.Tasks.Graphql.ValidateQuery.run([&quot;-s&quot;, schema_string, query_string]) :ok","ref":"Mix.Tasks.Graphql.ValidateQuery.html#run/1","title":"Mix.Tasks.Graphql.ValidateQuery.run/1","type":"function"},{"doc":"CommonGraphqlClient An Elixir libary for generating GraphQL clients. Adapters are provided for both HTTP (using HTTPoison) and WebSockets (using AbsintheWebSocket). Both adapters support GraphQL queries, whereas WebSockets are required for subscriptions. This library also supports client-side query validation using nodejs.","ref":"readme.html","title":"CommonGraphqlClient","type":"extras"},{"doc":"Docs can be found at https://hexdocs.pm/common_graphql_client. A complete walkthrough can be found on the Annkissam Alembic. It also has an associated demo.","ref":"readme.html#documentation","title":"CommonGraphqlClient - Documentation","type":"extras"},{"doc":"Add common_graphql_client to your list of dependencies in mix.exs: def deps do [ {:common_graphql_client, &quot;~&gt; 0.1.0&quot;}, {:httpoison, &quot;~&gt; 1.1&quot;}, # If using HTTP queries {:absinthe_websocket, &quot;~&gt; 0.2.0&quot;}, # If using WebSocket subscriptions (or WebSocket queries) ] end An example Mix config: config :my_app, MyAppApi.Context, client: MyAppApi.Client, query_caller: CommonGraphQLClient.Caller.Http, # If using HTTP queries. You can also use the WebSocket Caller. http_api_url: &quot;http://127.0.0.1:4000/api&quot;, # The URL for the HTTP Client subscription_caller: CommonGraphQLClient.Caller.WebSocket, # If using WebSocket subscriptions websocket_api_url: &quot;ws://127.0.0.1:4000/socket/websocket&quot; # The URL for the WebSocket Client (optional) If you&#39;re using absinthe_websocket, it has a supervisor that must be added to your supervision tree. This will be application specific: children = [ ... ] ++ [MyAppApi.Client.supervisor()] Supervisor.init(children, strategy: :one_for_one)","ref":"readme.html#installation","title":"CommonGraphqlClient - Installation","type":"extras"},{"doc":"The main entry point to the client will be the context. You can add additional methods, but it knows about [:list, :list_by, :get, :get_by] and their corresponding ! methods. The context is also responsible for implementing a subscibe/0 method (if using subscriptions). That method is called when the initial connection is made (to initiate any subscriptions) and on re-connection (to re-establish the subscriptions). It can also perform any initiation that needs to happen when the connection is established (for instance, syncing missing data). After the subscription is made, each notification will call the receive\\2 method. defmodule MyAppApi.Context do use CommonGraphQLClient.Context, otp_app: :my_app # Identical to calling MyAppApi.Context.list(:employees) def list_employees do list(:employees) end def find_employee_by_email!(email) do get_by(:employees, %{employee_email: email}) end def subscribe do # NOTE: This will call __MODULE__.receive(:employee_created, employee) when data is received client().subscribe_to(:employee_created, __MODULE__) # (optional) # sync_missing_data() end def receive(:employee_created, employee) do # do something with the created employee end end Your use case might necessitate the receive\\2 method exist on another module. The second parameter of subscribe_to allows a module to be specified. The code changes would look like this: defmodule MyAppApi.Context do ... def subscribe do client().subscribe_to(:employee_created, EmployeeNotificationHandler) end end defmodule EmployeeNotificationHandler do def receive(:employee_created, employee) do ... end end","ref":"readme.html#context","title":"CommonGraphqlClient - Context","type":"extras"},{"doc":"Your application will need a client. It will be responsible for turning symbols into various GraphQL Queries and Subscriptions. It&#39;ll also map the returned results into Ecto schemas. By calling use CommonGraphQLClient.Client, several methods will be made available. The client is responsible for implementing handle\\2, handle\\3, and handle_subscribe_to\\2 methods for each call the context makes: defmodule MyAppApi.Client do use CommonGraphQLClient.Client, otp_app: :my_app, mod: MyAppApi.Context defp handle(:list, :employees) do do_post( :employees, MyAppApi.Schema.Employee, MyAppApi.Query.Employee.list() ) end defp handle(:get, :employee, id), do: handle(:get_by, :employee, %{id: id}) defp handle(:get_by, :employee, variables) do do_post( :employee, MyAppApi.Schema.Employee, MyAppApi.Query.Employee.get_by(variables), variables ) end defp handle_subscribe_to(:employee_created, mod) do do_subscribe( mod, :employee_created, MyAppApi.Schema.Employee, MyAppApi.Subscription.Employee.employee_created() ) end end","ref":"readme.html#client","title":"CommonGraphqlClient - Client","type":"extras"},{"doc":"The client will map results into an ecto schema: defmodule MyAppApi.Schema.Employee do use CommonGraphQLClient.Schema api_schema do field :id, :integer field :name, :string field :email, :string end @cast_params ~w( id name email )a def changeset(struct, attrs) do struct |&gt; cast(attrs, @cast_params) end end By adjusting the changeset you can also map GraphQL associations into additional structs. For example, using cast_embed/3: defmodule MyAppApi.Schema.Employee do use CommonGraphQLClient.Schema api_schema do field :id, :integer field :name, :string embeds_many :email_records, EmailRecord do field :email, :string end end @cast_params ~w( id name )a def changeset(struct, attrs) do struct |&gt; cast(attrs, @cast_params) |&gt; cast_embed(:email_records, with: &amp;email_record_changeset/2) end defp email_record_changeset(struct, attrs) do struct |&gt; cast(attrs, [:email]) end end","ref":"readme.html#ecto-schemas","title":"CommonGraphqlClient - Ecto Schemas","type":"extras"},{"doc":"The example client suggests organizing GraphQL Queries using modules. A module approach would look like this: defmodule MyAppApi.Query.Employee do @moduledoc &quot;&quot;&quot; Employee GraphQL queries &quot;&quot;&quot; @doc false def list do &quot;&quot;&quot; query { employees { id name email } } &quot;&quot;&quot; end def get_by(%{email: _}) do &quot;&quot;&quot; query get_employee($email: String) { employee(email: $email) { id name } } &quot;&quot;&quot; end end","ref":"readme.html#graphql-queries","title":"CommonGraphqlClient - GraphQL Queries","type":"extras"},{"doc":"Similar to queries, the code to initiate subscriptions can be organized using modules: defmodule MyAppApi.Subscription.Employee do @moduledoc &quot;&quot;&quot; Subscription adapter module Employee &quot;&quot;&quot; @doc false def employee_created do &quot;&quot;&quot; subscription { employee_created { id name email } } &quot;&quot;&quot; end end","ref":"readme.html#graphql-subscriptions","title":"CommonGraphqlClient - GraphQL Subscriptions","type":"extras"},{"doc":"Client The HTTP Client can send Bearer tokens, whereas the WebSocket can send a token as a query param. Since these credentials should not be in source control, this library provides a way to set them at runtime. First, update the Mix config: config :my_app, MyAppApi.Context, ... load_from_system_env: true # add this Second, update your client: use CommonGraphQLClient.Client, ... http_api_token_func: fn -&gt; System.get_env(&quot;YOUR_API_TOKEN&quot;) || raise &quot;ENV Not Set: YOUR_API_TOKEN ENV&quot; end websocket_api_token_func: fn -&gt; System.get_env(&quot;YOUR_API_TOKEN&quot;) || raise &quot;ENV Not Set: YOUR_API_TOKEN ENV&quot; end And finally, call the init\\0 function from your application supervisor: defmodule MyApp.Supervisor do use Supervisor def start_link(opts) do Supervisor.start_link(__MODULE__, :ok, opts) end def init(:ok) do MyAppApi.Client.init() ... end end Alternatively, http_api_token\\0 and websocket_api_token\\0 can be overridden in the client to support other use cases. HTTP Server While this package supports creating clients, if you&#39;re also building the GraphQL API in Phoenix we can make some (simple) suggestions. These examples will use a shared token. They&#39;ll also use secure_compare to mitigate timing attacks. Your API will require more complexity if it needs to support multiple users or to differentiate between clients. A plug added to the router can secure your GraphQL API endpoint: pipeline :api do plug(:accepts, [&quot;json&quot;]) plug Api.Authentication # add this end # This is based on the Absinthe authentication documentation: # https://hexdocs.pm/absinthe/context-and-authentication.html defmodule Api.Authentication do @behaviour Plug import Plug.Conn def init(opts), do: opts def call(conn, _) do conn |&gt; fetch_token() |&gt; authorize_token() |&gt; case do :ok -&gt; conn |&gt; put_private(:absinthe, %{context: %{authorized: true}}) _ -&gt; conn |&gt; send_resp(401, &quot;Unauthorized&quot;) |&gt; halt end end def fetch_token(conn) do case get_req_header(conn, &quot;authorization&quot;) do [&quot;Bearer &quot; &lt;&gt; token] -&gt; token _ -&gt; nil end end def authorize_token(nil), do: :error def authorize_token(&quot;&quot;), do: :error def authorize_token(token) do case SecureCompare.compare(token, secret_token()) do true -&gt; :ok _ -&gt; :error end end def secret_token do System.get_env(&quot;YOUR_API_TOKEN&quot;) end end WebSocket Server To secure the WebSocket connection, update user_socket: defmodule MyAppWeb.UserSocket do ... def connect(%{&quot;token&quot; =&gt; token} = params, socket) do case SecureCompare.compare(token, Api.Authentication.secret_token()) do true -&gt; {:ok, socket} _ -&gt; :error end end end","ref":"readme.html#security","title":"CommonGraphqlClient - Security","type":"extras"},{"doc":"Query validation can be done at the client-side using schema introspection result to get closer to real integration tests without having to run a graphql server. This can be done using the mix task: $ mix graphql.validate_query -f schema.json &lt;raw-query&gt; $ mix graphql.validate_query -f schema.json $(cat &lt;query.graphql-path&gt;) For more usage options try the help command: $ mix graphql.validate_query -h If you don&#39;t want to use the mix task, validation can be done at a module level by explicitly calling the static validator module: schema_path = &quot;path/to/schema.json&quot; query_string = &quot;{ __schema { types { name } } }&quot; validation_strategy = :npm_graphql CommonGraphqlClient.StaticValidator.validate( query_string, %{validation_strategy: validation_strategy, schema_path: schema_path} ) # =&gt; :ok | {:error, error} Schema validation can be done using validation strategies. The default validation strategy is using :npm-graphql. This requires npm and node binaries to be available (which is for most of the phoenix development environment) For more information on this check out the documentation and examples for CommonGraphqlClient.StaticValidator.NpmGraphql Using npm-graphql This uses npm and node commands to run schema validation. Make sure you have npm and node installed. Using native elixir This strategy will use native elixir for performing the validation. This is work in progress","ref":"readme.html#client-side-query-validation-using-schema-introspection-result","title":"CommonGraphqlClient - Client-side Query Validation (using schema introspection result)","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"PR 15 Static Validation for query on the client side using npm_graphql","ref":"changelog.html#v-0-5-0","title":"Changelog - v.0.5.0","type":"extras"},{"doc":"PR 13) Better HTTPoison error handling in CommonGraphQLClient.Caller.Http.post\\4 Allow http_opts to be sent to CommonGraphQLClient.Caller.Http.post\\4","ref":"changelog.html#v-0-3-3","title":"Changelog - v.0.3.3","type":"extras"},{"doc":"Fix UndefinedFunctionError error on Caller.Http.post &amp; Caller.Nil.post","ref":"changelog.html#v-0-3-2","title":"Changelog - v.0.3.2","type":"extras"},{"doc":"Add configurable timeout and error logging (https://github.com/annkissam/common_graphql_client/pull/9)","ref":"changelog.html#v-0-3-1","title":"Changelog - v.0.3.1","type":"extras"},{"doc":"Initial Public Release","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"}]